import femto.Sprite;
import femto.Image;
import femto.mode.HiRes16Color;
import femto.input.Button;

import Common;

class HorizBarEntity 
{
   HorizBarEntity(float x, float y ) 
    { 
        image =  new BarH();
        //velX = 0;
        //velY = 0;
        setX(x);
        setY(y);
        halfWidth = image.width() / 2;
        halfHeight = image.height() / 2;
    }
    
    void setX(float x_) {x = x_; }
    float getX() {return x; }
    void setY(float y_) { y = y_; }
    float getY() { return y; }

    void update()
    {
        long currTime = System.currentTimeMillis();

        oldX = x;
        oldY = y;

        // Move the bar.
        if( Button.Up.isPressed() )
            y -= Common.BAR_SPEED;
        else if( Button.Down.isPressed() )
            y += Common.BAR_SPEED;
            
        // Check limits
        if(y<0) y = 0;
        if(y>176-4) y = 176-4;

        checkCollisionToZombies();
    }

    void draw(HiRes16Color screen)
    {
        image.draw(screen, x, y);
    }
    
    void checkCollisionToZombies()
    {
        //sprite.draw(screen); // Animation is updated automatically
        
        // Center point of the bar
        float barCenterY = y + halfHeight;
        
        for(int i=0; i < Common.MAX_ZOMBIES; i++)
        {
            ZombieEntity zomb =  Common.zombies[i];
            float zombX = zomb.getX();
            float zombY = zomb.getY();
            float zombW = zomb.sprite.width();
            float zombH = zomb.sprite.height();
            float zombCenterY = zombY + zomb.halfHeight;
            
            float diffOfCenters = barCenterY - zombCenterY;
            if(diffOfCenters>0 && diffOfCenters < (halfHeight + zomb.halfHeight))
            {
                // Put zombie above the bar
                Common.zombies[i].setY(y - zombH); 
            }
            else if(diffOfCenters<0 && -diffOfCenters < (halfHeight + zomb.halfHeight))
            {
                // Put zombie below the bar
                Common.zombies[i].setY(y + Common.BAR_THICKNESS);
            }
        }
    }
    
    // Member data
    
    public BarH image;
    public boolean test;
    public float x;
    public float y;
    public float oldX;
    public float oldY;
    //public float velX;
    //public float velY;
    public float halfWidth;
    public float halfHeight;
    
}

